package techreborn.blocks;

import java.util.List;
import java.util.Random;

import me.modmuss50.jsonDestroyer.api.ITexturedBlock;
import net.minecraft.block.Block;
import net.minecraft.block.material.Material;
import net.minecraft.block.properties.PropertyInteger;
import net.minecraft.block.state.BlockStateContainer;
import net.minecraft.block.state.IBlockState;
import net.minecraft.creativetab.CreativeTabs;
import net.minecraft.item.Item;
import net.minecraft.item.ItemStack;
import net.minecraft.tileentity.TileEntity;
import net.minecraft.util.EnumFacing;
import net.minecraft.util.math.BlockPos;
import net.minecraft.world.IBlockAccess;
import net.minecraft.world.World;
import net.minecraftforge.fml.relauncher.Side;
import net.minecraftforge.fml.relauncher.SideOnly;
import reborncore.common.multiblock.BlockMultiblockBase;
import techreborn.client.TechRebornCreativeTab;
import techreborn.tiles.TileMachineCasing;

public class BlockMachineCasing extends BlockMultiblockBase implements ITexturedBlock
{

	public static final String[] types = new String[] { "standard", "reinforced", "advanced" };
	public PropertyInteger METADATA;

	public BlockMachineCasing(Material material)
	{
		super(material);
		func_149647_a(TechRebornCreativeTab.instance);
		func_149663_c("techreborn.machineCasing");
		func_149711_c(2F);
		this.func_180632_j(this.func_176223_P().func_177226_a(METADATA, 0));
	}

	@Override
	public IBlockState func_176203_a(int meta)
	{
		return this.func_176223_P().func_177226_a(METADATA, meta);
	}

	@Override
	public int func_176201_c(IBlockState state)
	{
		return state.func_177229_b(METADATA);
	}

	protected BlockStateContainer func_180661_e()
	{

		METADATA = PropertyInteger.func_177719_a("type", 0, types.length);
		return new BlockStateContainer(this, METADATA);
	}

	public int getHeatFromState(IBlockState state)
	{
		switch (func_176201_c(state))
		{
			case 0:
				return 1020 / 25;
			case 1:
				return 1700 / 25;
			case 2:
				return 2380 / 25;
		}
		return 0;
	}

	@Override
	public Item func_180660_a(IBlockState state, Random rand, int fortune)
	{
		return Item.func_150898_a(this);
	}

	@Override
	@SideOnly(Side.CLIENT)
	public void func_149666_a(Item item, CreativeTabs creativeTabs, List list)
	{
		for (int meta = 0; meta < types.length; meta++)
		{
			list.add(new ItemStack(item, 1, meta));
		}
	}

	@Override
	public int func_180651_a(IBlockState state)
	{
		int meta = func_176201_c(state);
		return meta;
	}

	@Override
	public TileEntity func_149915_a(World p_149915_1_, int p_149915_2_)
	{
		return new TileMachineCasing();
	}

	@Override
	public boolean func_176225_a(IBlockState blockState, IBlockAccess worldIn, BlockPos pos, EnumFacing side)
	{
		Block b = worldIn.func_180495_p(pos).func_177230_c();
		return b != (Block) this && super.func_176225_a(blockState, worldIn, pos, side);
	}

	public boolean shouldConnectToBlock(IBlockAccess blockAccess, int x, int y, int z, Block block, int meta)
	{
		return block == this;
	}

	@Override
	public String getTextureNameFromState(IBlockState blockState, EnumFacing facing)
	{
		return "techreborn:blocks/machine/machine_blocks/casing" + types[func_176201_c(blockState)] + "_full";
	}

	@Override
	public int amountOfStates()
	{
		return types.length;
	}
}
