package techreborn.client.gui;

import java.io.IOException;

import net.minecraft.client.gui.GuiButton;
import net.minecraft.client.gui.inventory.GuiContainer;
import net.minecraft.client.renderer.GlStateManager;
import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.util.ResourceLocation;
import net.minecraft.util.text.translation.I18n;
import reborncore.client.gui.GuiUtil;
import reborncore.client.multiblock.MultiblockSet;
import reborncore.common.misc.Location;
import reborncore.common.multiblock.CoordTriplet;
import techreborn.client.ClientMultiBlocks;
import techreborn.client.container.ContainerVacuumFreezer;
import techreborn.proxies.ClientProxy;
import techreborn.tiles.TileVacuumFreezer;

public class GuiVacuumFreezer extends GuiContainer
{

	public static final ResourceLocation texture = new ResourceLocation("techreborn",
			"textures/gui/vacuum_freezer.png");

	TileVacuumFreezer crafter;
	ContainerVacuumFreezer containerVacuumFreezer;

	public GuiVacuumFreezer(EntityPlayer player, TileVacuumFreezer tilealloysmelter)
	{
		super(new ContainerVacuumFreezer(tilealloysmelter, player));
		this.field_146999_f = 176;
		this.field_147000_g = 167;
		crafter = tilealloysmelter;
		this.containerVacuumFreezer = (ContainerVacuumFreezer) this.field_147002_h;
	}

	@Override
	public void func_73866_w_()
	{
		int k = (this.field_146294_l - this.field_146999_f) / 2;
		int l = (this.field_146295_m - this.field_147000_g) / 2;
		GuiButton button = new GuiButton(212, k + this.field_146999_f - 24, l + 4, 20, 20, "");
		field_146292_n.add(button);
		super.func_73866_w_();
		CoordTriplet coordinates = new CoordTriplet(crafter.func_174877_v().func_177958_n(), crafter.func_174877_v().func_177956_o() - 5,
				crafter.func_174877_v().func_177952_p());
		if (coordinates.equals(ClientProxy.multiblockRenderEvent.anchor))
		{
			ClientProxy.multiblockRenderEvent.setMultiblock(null);
			button.field_146126_j = "B";
		} else
		{
			button.field_146126_j = "A";
		}
	}

	@Override
	protected void func_146976_a(float p_146976_1_, int p_146976_2_, int p_146976_3_)
	{
		GlStateManager.func_179131_c(1.0F, 1.0F, 1.0F, 1.0F);
		this.field_146297_k.func_110434_K().func_110577_a(texture);
		int k = (this.field_146294_l - this.field_146999_f) / 2;
		int l = (this.field_146295_m - this.field_147000_g) / 2;
		this.func_73729_b(k, l, 0, 0, this.field_146999_f, this.field_147000_g);

		int j = 0;

		j = crafter.getProgressScaled(24);
		if (j > 0)
		{
			this.func_73729_b(k + 79, l + 37, 176, 14, j + 1, 16);
		}

		j = (int)(crafter.getEnergy() * 12f / crafter.getMaxPower());
		if (j > 0)
		{
			this.func_73729_b(k + 26, l + 36 + 12 - j, 176, 12 - j, 14, j + 2);
		}

		if (containerVacuumFreezer.machineStatus == 0)
		{
			GuiUtil.drawTooltipBox(k + 30, l + 50 + 12 - 0, 114, 10);
			this.field_146289_q.func_78276_b(I18n.func_74838_a("techreborn.message.missingmultiblock"), k + 38,
					l + 52 + 12 - 0, -1);
		}
	}

	protected void func_146979_b(int p_146979_1_, int p_146979_2_)
	{
		String name = I18n.func_74838_a("tile.techreborn.vacuumfreezer.name");
		this.field_146289_q.func_78276_b(name, this.field_146999_f / 2 - this.field_146289_q.func_78256_a(name) / 2, 6,
				4210752);
		this.field_146289_q.func_78276_b(I18n.func_74837_a("container.inventory", new Object[0]), 8,
				this.field_147000_g - 96 + 2, 4210752);
	}

	@Override
	public void func_146284_a(GuiButton button) throws IOException
	{
		super.func_146284_a(button);
		if (button.field_146127_k == 212)
		{
			if (ClientProxy.multiblockRenderEvent.currentMultiblock == null)
			{
				{// This code here makes a basic multiblock and then sets to the
					// selected one.
					MultiblockSet set = new MultiblockSet(ClientMultiBlocks.frezzer);
					ClientProxy.multiblockRenderEvent.setMultiblock(set);
					ClientProxy.multiblockRenderEvent.partent = new Location(crafter.func_174877_v().func_177958_n(),
							crafter.func_174877_v().func_177956_o(), crafter.func_174877_v().func_177952_p(), crafter.func_145831_w());
					ClientProxy.multiblockRenderEvent.anchor = new CoordTriplet(crafter.func_174877_v().func_177958_n(),
							crafter.func_174877_v().func_177956_o() - 5, crafter.func_174877_v().func_177952_p());
				}
				button.field_146126_j = "A";
			} else
			{
				ClientProxy.multiblockRenderEvent.setMultiblock(null);
				button.field_146126_j = "B";
			}
		}
	}
}
