package techreborn.compat.tinkers;

import net.minecraft.item.EnumRarity;
import net.minecraft.nbt.NBTTagCompound;
import net.minecraft.nbt.NBTTagList;
import net.minecraft.util.ResourceLocation;
import net.minecraftforge.fluids.Fluid;
import net.minecraftforge.fluids.FluidRegistry;
import net.minecraftforge.fml.common.event.FMLInterModComms;
import slimeknights.tconstruct.library.fluid.FluidMolten;

/**
 * @author Prospector on 08/05/16
 */
public class TinkersFluids
{
	private static ResourceLocation moltenMetal = new ResourceLocation("tconstruct:blocks/fluids/molten_metal");
	private static ResourceLocation moltenMetalFlowing = new ResourceLocation(
			"tconstruct:blocks/fluids/molten_metal_flow");

	public static FluidMolten moltenChrome = new FluidMolten("chrome", 0x90C9C9, moltenMetal, moltenMetalFlowing);
	public static FluidMolten moltenInvar = new FluidMolten("invar", 0x7F907F, moltenMetal, moltenMetalFlowing);
	public static FluidMolten moltenIridium = new FluidMolten("iridium", 0xFFFFFF, moltenMetal, moltenMetalFlowing);
	public static FluidMolten moltenPlatinum = new FluidMolten("platinum", 0x34BFBF, moltenMetal, moltenMetalFlowing);
	public static FluidMolten moltenTitanium = new FluidMolten("titanium", 0x3C372F, moltenMetal, moltenMetalFlowing);
	public static FluidMolten moltenTungsten = new FluidMolten("tungsten", 0x3A464F, moltenMetal, moltenMetalFlowing);

	public static void init()
	{
		addFluidStuff(moltenChrome, "Chrome");
		moltenChrome.setTemperature(800);
		addFluidStuff(moltenInvar, "Invar");
		moltenInvar.setTemperature(580);
		addFluidStuff(moltenIridium, "Iridium");
		moltenIridium.setTemperature(4000);
		moltenIridium.setRarity(EnumRarity.EPIC);
		addFluidStuff(moltenPlatinum, "Platinum");
		moltenPlatinum.setTemperature(900);
		addFluidStuff(moltenTitanium, "Titanium");
		moltenTitanium.setTemperature(1000);
		addFluidStuff(moltenTungsten, "Tungsten");
		moltenTungsten.setTemperature(1200);

		//Invar Alloying
		NBTTagList tagList = new NBTTagList();
		NBTTagCompound fluid = new NBTTagCompound();
		fluid.func_74778_a("FluidName", "invar");
		fluid.func_74768_a("Amount", 144);
		tagList.func_74742_a(fluid);
		fluid = new NBTTagCompound();
		fluid.func_74778_a("FluidName", "iron");
		fluid.func_74768_a("Amount", 96);
		tagList.func_74742_a(fluid);
		fluid = new NBTTagCompound();
		fluid.func_74778_a("FluidName", "nickel");
		fluid.func_74768_a("Amount", 48);
		tagList.func_74742_a(fluid);

		NBTTagCompound message = new NBTTagCompound();
		message.func_74782_a("alloy", tagList);
		FMLInterModComms.sendMessage("tconstruct", "alloy", message);
	}

	public static void addFluidStuff(Fluid fluid, String oreSuffix)
	{
		FluidRegistry.registerFluid(fluid);
		FluidRegistry.addBucketForFluid(fluid);
		NBTTagCompound tag = new NBTTagCompound();
		tag.func_74778_a("fluid", fluid.getName());
		tag.func_74778_a("ore", oreSuffix);
		tag.func_74757_a("toolforge", true);
		FMLInterModComms.sendMessage("tconstruct", "integrateSmeltery", tag);
	}
}
