package techreborn.tiles;

import reborncore.common.IWrenchable;
import net.minecraft.block.Block;
import net.minecraft.block.material.Material;
import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.init.Blocks;
import net.minecraft.init.Items;
import net.minecraft.item.*;
import net.minecraft.util.EnumFacing;
import net.minecraftforge.fml.common.registry.GameRegistry;
import reborncore.api.recipe.IBaseRecipeType;
import reborncore.api.recipe.RecipeHandler;
import reborncore.api.tile.IInventoryProvider;
import reborncore.common.tile.TileMachineBase;
import reborncore.common.util.Inventory;
import reborncore.common.util.ItemUtils;
import techreborn.api.Reference;
import techreborn.init.ModBlocks;

public class TileAlloyFurnace extends TileMachineBase implements IWrenchable, IInventoryProvider {

	public int tickTime;
	public Inventory inventory = new Inventory(4, "TileAlloyFurnace", 64, this);
	public int burnTime;
	public int currentItemBurnTime;
	public int cookTime;
	int input1 = 0;
	int input2 = 1;
	int output = 2;
	int fuel = 3;

	public TileAlloyFurnace() {

	}

	/**
	 * Returns the number of ticks that the supplied fuel item will keep the
	 * furnace burning, or 0 if the item isn't fuel
	 */
	public static int getItemBurnTime(ItemStack stack) {
		if (stack == null) {
			return 0;
		} else {
			Item item = stack.func_77973_b();

			if (item instanceof ItemBlock && Block.func_149634_a(item) != Blocks.field_150350_a) {
				Block block = Block.func_149634_a(item);

				if (block == Blocks.field_150376_bx) {
					return 150;
				}

				if (block.func_149688_o(block.func_176223_P()) == Material.field_151575_d) {
					return 300;
				}

				if (block == Blocks.field_150402_ci) {
					return 16000;
				}
			}

			if (item instanceof ItemTool && ((ItemTool) item).func_77861_e().equals("WOOD"))
				return 200;
			if (item instanceof ItemSword && ((ItemSword) item).func_150932_j().equals("WOOD"))
				return 200;
			// if (item instanceof ItemHoe && ((ItemHoe)
			// item).getToolMaterialName().equals("WOOD")) return 200;
			if (item == Items.field_151055_y)
				return 100;
			if (item == Items.field_151044_h)
				return 1600;
			if (item == Items.field_151129_at)
				return 20000;
			if (item == Item.func_150898_a(Blocks.field_150345_g))
				return 100;
			if (item == Items.field_151072_bj)
				return 2400;
			return GameRegistry.getFuelValue(stack);
		}
	}

	@Override
	public void func_73660_a() {
		super.func_73660_a();
		boolean flag = this.burnTime > 0;
		boolean flag1 = false;
		if (this.burnTime > 0) {
			--this.burnTime;
		}
		if (!this.field_145850_b.field_72995_K) {
			if (this.burnTime != 0 || func_70301_a(input1) != null && func_70301_a(fuel) != null) {
				if (this.burnTime == 0 && this.canSmelt()) {
					this.currentItemBurnTime = this.burnTime = getItemBurnTime(func_70301_a(fuel));
					if (this.burnTime > 0) {
						flag1 = true;
						if (this.func_70301_a(fuel) != null) {
							func_70298_a(fuel, 1);
						}
					}
				}
				if (this.isBurning() && this.canSmelt()) {
					++this.cookTime;
					if (this.cookTime == 200) {
						this.cookTime = 0;
						this.smeltItem();
						flag1 = true;
					}
				} else {
					this.cookTime = 0;
				}
			}
			if (flag != this.burnTime > 0) {
				flag1 = true;
				// TODO sync on/off
			}
		}
		if (flag1) {
			this.func_70296_d();
		}
	}

	public boolean hasAllInputs(IBaseRecipeType recipeType) {
		if (recipeType == null) {
			return false;
		}
		for (ItemStack input : recipeType.getInputs()) {
			Boolean hasItem = false;
			for (int inputslot = 0; inputslot < 2; inputslot++) {
				if (ItemUtils.isItemEqual(input, inventory.func_70301_a(inputslot), true, true,
						recipeType.useOreDic()) && inventory.func_70301_a(inputslot).field_77994_a >= input.field_77994_a) {
					hasItem = true;
				}
			}
			if (!hasItem)
				return false;
		}
		return true;
	}

	private boolean canSmelt() {
		if (this.func_70301_a(input1) == null || this.func_70301_a(input2) == null) {
			return false;
		} else {
			ItemStack itemstack = null;
			for (IBaseRecipeType recipeType : RecipeHandler.getRecipeClassFromName(Reference.alloySmelteRecipe)) {
				if (hasAllInputs(recipeType)) {
					itemstack = recipeType.getOutput(0);
					break;
				}
			}

			if (itemstack == null)
				return false;
			if (this.func_70301_a(output) == null)
				return true;
			if (!this.func_70301_a(output).func_77969_a(itemstack))
				return false;
			int result = func_70301_a(output).field_77994_a + itemstack.field_77994_a;
			return result <= func_70297_j_() && result <= this.func_70301_a(output).func_77976_d(); // Forge
			// BugFix:
			// Make
			// it
			// respect
			// stack
			// sizes
			// properly.
		}
	}

	/**
	 * Turn one item from the furnace source stack into the appropriate smelted
	 * item in the furnace result stack
	 */
	public void smeltItem() {
		if (this.canSmelt()) {
			ItemStack itemstack = null;
			for (IBaseRecipeType recipeType : RecipeHandler.getRecipeClassFromName(Reference.alloySmelteRecipe)) {
				if (hasAllInputs(recipeType)) {
					itemstack = recipeType.getOutput(0);
					break;
				}
				if (itemstack != null) {
					break;
				}
			}

			if (this.func_70301_a(output) == null) {
				func_70299_a(output, itemstack.func_77946_l());
			} else if (this.func_70301_a(output).func_77973_b() == itemstack.func_77973_b()) {
				func_70298_a(output, -itemstack.field_77994_a);
			}

			for (IBaseRecipeType recipeType : RecipeHandler.getRecipeClassFromName(Reference.alloySmelteRecipe)) {
				boolean hasAllRecipes = true;
				if (hasAllInputs(recipeType)) {

				} else {
					hasAllRecipes = false;
				}
				if (hasAllRecipes) {
					for (ItemStack input : recipeType.getInputs()) {
						for (int inputSlot = 0; inputSlot < 2; inputSlot++) {
							if (ItemUtils.isItemEqual(input, inventory.func_70301_a(inputSlot), true, true,
									recipeType.useOreDic())) {
								inventory.func_70298_a(inputSlot, input.field_77994_a);
								break;
							}
						}
					}
				}
			}

		}
	}

	/**
	 * Furnace isBurning
	 */
	public boolean isBurning() {
		return this.burnTime > 0;
	}

	public int getBurnTimeRemainingScaled(int scale) {
		if (this.currentItemBurnTime == 0) {
			this.currentItemBurnTime = 200;
		}

		return this.burnTime * scale / this.currentItemBurnTime;
	}

	public int getCookProgressScaled(int scale) {
		return this.cookTime * scale / 200;
	}

	@Override
	public boolean wrenchCanSetFacing(EntityPlayer entityPlayer, EnumFacing side) {
		return false;
	}

	@Override
	public EnumFacing getFacing() {
		return getFacingEnum();
	}

	@Override
	public boolean wrenchCanRemove(EntityPlayer entityPlayer) {
		return entityPlayer.func_70093_af();
	}

	@Override
	public float getWrenchDropRate() {
		return 1.0F;
	}

	@Override
	public ItemStack getWrenchDrop(EntityPlayer entityPlayer) {
		return new ItemStack(ModBlocks.AlloyFurnace, 1);
	}

	public boolean isComplete() {
		return false;
	}

	@Override
	public Inventory getInventory() {
		return inventory;
	}

}
